cls
@echo off

IF "%1"=="" GOTO AIDE
rem IF exist "%2" %adrbase% = %2 else %adrbase% = "0x170"

if not exist %1.c goto NOC

echo ---------------------------------------------------------
echo -- Effacement des fichiers
del %1.asm
del %1.ihx
del %1.lk
del %1.lst
del %1.map
del %1.noi
del %1.rel
del %1.sym
del %1.bin
del %1.dsk

echo ---------------------------------------------------------
echo adresse de base : 0x170
echo il faut le crt0_0x170 !

echo ---------------------------------------------------------
echo --Compilation de %1.c
sdcc -mz80 --code-loc 0x1A8 --data-loc 0 --no-std-crt0 --no-peep --opt-code-speed crt0_0x170.rel putchar.rel conio2.rel amsgraph.rel %1.c

rem -mz80 -> Generate code for the Zilog Z80 family of processo. (Processor Selection Options)
rem --code-loc 0x6038 -> The start location of the code segment. (Linker Options)
rem --data-loc 0 -> The start location of the internal ram data segment.(Linker Options)
rem --no-std-crt0 -> When linking, skip the standard crt0.rel object file.(Z80 Options)

rem --opt-code-speed -> The compiler will optimize code generation towards fast code
rem --opt-code-size -> The compiler will optimize code generation towards compact code


if not exist %1.ihx goto NOIHX
echo ---------------------------------------------------------
echo --Creation de %1.bin
hex2bin %1.ihx

if not exist %1.bin goto NOBIN
echo ---------------------------------------------------------
echo --Creation de %1.dsk
CPCDiskXP -File %1.bin -AddAmsdosHeader 170 -AddToNewDsk %1.dsk
rem PCDiskXP -File BOING.SCR -AddToExistingDsk %1.dsk

goto FIN

exit

:AIDE
echo ---------------------------------------------------------
echo Utilisation : comp.bat "non fichier" sans extention ! 
goto Fin

:NOC
echo ---------------------------------------------------------
echo Le fichier %1.c n'existe pas !
goto Fin

:NOIHX
echo ---------------------------------------------------------
echo Erreur de compilation du C !
rem echo Erreur dans le fichier %1_comp.log
goto Fin

:NOBIN
echo ---------------------------------------------------------
echo Erreur de compilation ASM !
goto Fin

:OK
echo ---------------------------------------------------------
echo Compilation de %1.c : OK
echo Creation de %1.bin : OK
echo Creation de %1.dsk : OK

:FIN
echo ---------------------------------------------------------
echo Fertig...